/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */



package lapis;

public class CachedPattern implements Pattern {
    Pattern pat;

    public CachedPattern (Pattern pat) {
        this.pat = pat;
    }

    public Pattern getPattern () {
        return pat;
    }

    public RegionSet match (Document doc) {
        PatternCache cache = doc.getPatternCache ();
        RegionSet s = cache.get (this);
        if (s == null) {
            s = pat.match (doc);
            cache.put (this, s);
        }
        return s;
    }
}
