/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */



package lapis;


public class DelayedRegionSet extends RegionSet {
    Pattern pat;
    Document doc;
    RegionSet s;

    public DelayedRegionSet (Pattern pat, Document doc) {
        this.pat = pat;
        this.doc = doc;
    }

    RegionSet getRegionSet () {
        if (s == null)
            s = pat.match (doc);
        return s;
    }

    public int getSize () {
        return getRegionSet ().getSize ();
    }

    public RegionEnumeration regions (Region bbox) {
        return getRegionSet ().regions (bbox);
    }

	public RegionEnumeration regions (RegionSet bboxs) {
		return getRegionSet ().regions (bboxs);
	}

    public RegionSet freeze () {
        return getRegionSet ().freeze ();
    }

    public SubsetEnumeration singleDocize () {
		return getRegionSet ().singleDocize ();
    }
    
    public SingleDocRegionSet getSingleDocRegionSet(Document doc) {
    	return getRegionSet ().getSingleDocRegionSet(doc);
    }
    
    public Versions getVersions() {
        return getRegionSet().getVersions();
    }
}

