/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */



package lapis;

import java.util.*;

/**
 * Standard Java enumeration for the regions in a RegionSet.
 */
public class JavaEnumeration implements Enumeration {
    RegionEnumeration re;
    boolean fast;
    Region r;

    public JavaEnumeration (RegionEnumeration re, boolean fast) {
        this.re = re;
        this.fast = fast;
        r = fast ? re.firstFast () : re.first ();
    }

    public boolean hasMoreElements () {
        return r != null;
    }

    public Object nextElement () {
        if (r == null)
            throw new NoSuchElementException ();
        Region s = r;
        r = fast ? re.nextFast () : re.next ();
        return s;
    }
}
