/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */



package lapis;

import java.util.*;

public class Relation {

    Hashtable map = new Hashtable ();

    public Relation () {
    }

    public RegionSet get (Region key) {
        RegionSet value = (RegionSet) map.get (key);
        return (value != null) ? value : RegionSet.EMPTY;
    }

    public boolean put (Region key, RegionSet value) {
        return map.put (key, value) != null;
    }

    public boolean add (Region key, Region value) {
        RegionSet curr = (RegionSet) map.get (key);
        
        if (curr == null)
            curr = value.freeze ();
        else {
            MutableRegionSet m = 
                (curr instanceof MutableRegionSet)
                ? (MutableRegionSet) curr
                : new MutableRegionSet (curr);
            m.insert (value);
            curr = m;
        }

        return map.put (key, curr) != null;
    }

}
