/*
 * Created on May 11, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package lapis.maps;

import lapis.*;
import lapis.Region;
import java.util.*;
import lapis.ml.*;
/**
 * @author alisa_m
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LexMap extends HashMap {
	public static lapisx.util.Debug debug = lapisx.util.Debug.QUIET;

	Document doc;

	public LexMap(DocumentView doc) {
		super();
		this.doc = doc.getDocument();
	}
	public LexMap(Document doc) {
		super();
		this.doc = doc;
	}
	public void add(String word, int start, int end, String lexLink) {
		LexNode lexNode = new LexNode(word, lexLink);
		Region r = new Region(start, end, doc.getVersion());
		put(r, lexNode);
	}
	public void add(Region r, LexNode lexNode) {
		put(r, lexNode);
	}
	public Enumeration getFeatures(NamedRegionSet ns){
		Vector features = new Vector();
		RegionEnumeration e = ns.regions();
		for (Region r = e.first (); r != null; r = e.next ()) {
			String  lexLink = getFeature(r);
			Feature feature = new Feature(r, "lexically attracted to: " +lexLink);
 			features.add(feature);
 		}
 		return features.elements();
		
	}

	public String getFeature(Region r) {
		LexNode lexNode = (LexNode) this.get(r);
		if (lexNode != null)
			return lexNode.getLexLink();

		Iterator keys = this.keySet().iterator();
		while (keys.hasNext()) {
			Region test = (Region) keys.next();
			if ((test.getStart() <= r.getStart())
				&& (test.getEnd() >= r.getEnd())){
				
				lexNode = (LexNode) this.get(test);
				return lexNode.getLexLink();
				}
		}
		return null;
	}

	public class LexNode {
		private String word;

		private String lexLink;

		public LexNode(String word, String lexLink) {
			setWord(word);

			setLexLink(lexLink);
		}

		void setWord(String word) {
			this.word = word;
		}

		String getWord() {
			return word;
		}

		void setLexLink(String lexLink) {
			this.lexLink = lexLink;
		}

		public String getLexLink() {
			return lexLink;
		}
	}

}
