/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapis.ml;

import lapis.*;
import lapisx.enum.*;

public interface InferenceAlgorithm {

    public RestartableEnumeration generalize (NamedRegionSet pos,
                                              NamedRegionSet neg);

    public NamedRegionSet getRecords ();

    public void addEditLocation (NamedRegionSet endpoints, int len);

    public void addPasteLocation (NamedRegionSet targetEnds, NamedRegionSet sourceSelection);

    public void addCopyLocation (NamedRegionSet sel);

    public void undoTo (DocumentVersion ver);
    
    /**
     * Free this algorithm's resources, if it uses any.  Usually used to 
     * remove listeners from the PatternLibrary.
     */
    public void close ();
}
