/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapis.ml;

public class InverseVarianceMetric extends DistanceMetric {
    public InverseVarianceMetric (DataSet ex) {
        double nEx = ex.getSize (); // declared as double for maxV calculation
        double maxV = (nEx - 1) / (nEx * nEx);

        int n = ex.variance.length;
        weight = new double[n];
        for (int i = 0; i < n; ++i) {
            double v = ex.variance[i];
            weight[i] = (v > 0.0) ? maxV/v : 0.0;
        }
        pruneWeights (weight, ex.features);
    }
}
