/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapis.swing;

import java.awt.*;
import lapisx.progress.*;
import lapisx.progress.swing.SwingProgressBar;


public class BrowserProgressBar extends SwingProgressBar { 
    Browser browser;

    public BrowserProgressBar (Browser browser) {
        this.browser = browser;

        setStringPainted (false);
        Dimension size = getMinimumSize ();
        if (size.width < 100)
            setMinimumSize (new Dimension (100, size.height));
    }
    
    public void setString (String label) {
        if (label != null)
            browser.setStatus (label + "...");
    }
    
    public void doneProgress (ProgressEvent event) {
        super.doneProgress (event);
        browser.clearStatus ();
    }
}
