/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import java.awt.*;
import javax.swing.text.*;

public class HiddenView extends javax.swing.text.ComponentView {
    /**
     * Creates a new HiddenView object.
     *
     * @param elem the element to decorate
     */
    public HiddenView(Element elem) {
	super(elem);
    }

    public float getAlignment(int axis) {
        // anchor to upper left corner of parent view
	return 0.0f;
    }


    public float getMinimumSpan(int axis) {
	return 0;
    }

    public float getPreferredSpan(int axis) {
	return 0;
    }

    public float getMaximumSpan(int axis) {
	return 0;
    }

    public void paint(Graphics g, Shape allocation) {
        setSize (0, 0);
    }

    // I'd rather this view were invisible, 
    // but making it invisible screws up its layout, which
    // in turn screws up modelToView() and highlighting.
    public boolean isVisible() {
	return true;
    }

}
