/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

public abstract class Log {
    static boolean logging = false;
    static long start = System.currentTimeMillis ();

    public static void println (String message) {
        if (logging) {
            long t = System.currentTimeMillis () - start;
            Browser.debug.println ("@" + t + " " + message);
        }
    }

    public static void open () {
        logging = true;
    }

    public static void close () {
        logging = false;
    }

    public static boolean isOpen () {
        return logging;
    }
}
