/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

/**
 * Interface for background tasks that can throw exceptions.
 * Equivalent to {@link java.lang.Runnable}, but the run method
 * may throw any Exception.
 */
public interface RunnableWithExceptions {
    /**
     * Run a background task.
     */
    public void run () throws Exception;
}

