/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */
package lapis.swing;

import lapis.NamedRegionSet;

/**
 * Listener, attached to a browser, that receives events when the
 * browser's selection changes.
 */
public interface SelectionListener {

    /**
     * Called after the browser's selection changes.
     * @param browser Browser which is loading the document
     * @param sel New selection
     */
    public void changedSelection (Browser browser, NamedRegionSet sel);
}
