/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import lapis.*;
import lapisx.util.Debug;
import lapisx.net.URLUtil;

public class Splash implements Tool {

  public static Debug debug = Debug.QUIET;
  
  public Document invoke(Arguments args) throws Exception {
    
    String splashImage = Main.getConfig().getProperty("lapis.splash-image");
    debug.println("lapis.splash-image: " + splashImage);
    Document doc = null;

    if(splashImage != null) {
      String splashPath = URLUtil.HrefToFile(splashImage, Main.getLapisDir()).toString();
      debug.println("Splash-image: " + splashPath);
      SplashWindow splashWindow = new SplashWindow(splashPath, null);
    

      // Instantiate a Browser shell and pass on the arguments
      Tool shell = (Tool) Class.forName("lapis.swing.Browser").newInstance();
      debug.println("Created a new Browser instance...");
      doc = shell.invoke(args);

      // make splash screen disappear
      splashWindow.setVisible(false);
      splashWindow.dispose();
    }
    return doc;
  }
  
}
