/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import lapisx.util.Debug;

public class SplashWindow extends JWindow {

  public static Debug debug = Debug.QUIET;

  public SplashWindow(String filename, Frame f) {
    super(f);
    JLabel l = new JLabel(new ImageIcon(filename));
    debug.println("grokked image...");
    getContentPane().add(l, BorderLayout.CENTER);
    pack();

    debug.println ("label height=" + l.getSize ().height);
    debug.println ("window height=" + getSize ().height);

    Dimension screenSize =
      Toolkit.getDefaultToolkit().getScreenSize();
    Dimension labelSize = l.getPreferredSize();
    setLocation(screenSize.width/2 - (labelSize.width/2),
		screenSize.height/2 - (labelSize.height/2));
    addMouseListener(new MouseAdapter()
      {
	public void mousePressed(MouseEvent e)
	{
	  setVisible(false);
	  dispose();
	}
      });
    debug.println("It's showtime, folks...");
    setVisible(true);
  }  
}
