/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import lapis.*;
import java.io.*;
import lapisx.util.Str;

public class StatusWriter extends DocumentWriter {
    StringWriter out;
    Browser browser;

    public StatusWriter (Browser browser) {
        this (browser.getFactory (), new StringWriter ());
        this.browser = browser;
    }

    private StatusWriter (DocumentFactory factory, StringWriter out) {
        super (factory, (Writer)out);
        this.out = out;
    }

    public void close () {
        super.close ();
        browser.setStatus (Str.abbreviate (out.toString (), 150));
    }
}
