/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import lapisx.util.Debug;
import java.io.*;

public class Timestamped extends Debug.Verbose {
    long startTime = System.currentTimeMillis ();
            
    public Timestamped () {
    }
    public Timestamped (PrintStream out) {
        super (out);
    }
    public void print (String message) {
        super.print (now () + message);
    }
    public void println (String message) {
        super.println (now () + message);
    }
    public void print (Object obj) {
        super.print (now () + obj);
    }
    public void println (Object obj) {
        super.println (now () + obj);
    }

    String now () {
        long msec = System.currentTimeMillis () - startTime;
        long sec = msec/1000;
        msec %= 1000;

        return sec + "." 
            + ((msec < 10) 
               ? "00" 
               : (msec < 100) ? "0" : "")
            + msec
            + " ";
    }

    public void close () {
        out.close ();
    }
}
