/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing;

import lapis.*;


public class ViewNow implements Tool {
    Browser browser;

    public ViewNow (Browser browser) {
        this.browser = browser;
    }

    public Document invoke (Arguments args) throws Exception {
        args.setUsage (
                         "Usage:\n"
                       + "   view    displays current document in browser window\n"
                       + "\n"
                       + "Options include:\n"
                       + "    -help           Display this message\n"
                       );
        while (args.hasMoreElements ()) {
            String name = args.nextName ();
            args.consume (name);
        }
                
        Document doc = args.getInput ();
        browser.setDocument (doc);
        browser.waitUntilLoaded ();
        return doc;
    }
}
