/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.swing.cluster;
import lapis.NamedRegionSet;
import lapis.swing.cluster.MatchNodeCreator.Node;

public interface MatchDisplayPanel {

	/**
	 * selects all matches displayed
	 **/
	public void selectAll();

	/**
	 * highlights in browser all matches displayed
	 **/
	public void highlightAll();
	/**
	 * unselects all matches found
	 **/
	public void clearSelection();

	/**
	 * deletes the selection from the display
	 **/
	public void deleteSelection();

	public void undo();

	public Node findNodeMatch(NamedRegionSet sel);
	public boolean componentHasFocus();
}
