/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapis.tc;

public interface TCSymbols {
    static final int NIL = 0;

    /* nouns */
    static final int NOUN = 1;
    static final int NOTHING = 2;
    static final int LIT = 3;
    static final int REGEXP = 4;
    static final int ID = 5;
    static final int ANY = 53;

    /* relops */
    static final int RELOP = 6;
    static final int EQUALS = 7;
    static final int BEFORE = 8;
    static final int AFTER = 9;
    static final int BEFORE_DELIMITED = 10;
    static final int AFTER_DELIMITED = 11;
    static final int JUST_BEFORE = 12;
    static final int JUST_AFTER = 13;
    static final int JUST_BEFORE_DELIMITED = 14;
    static final int JUST_AFTER_DELIMITED = 15;
    static final int CONTAINS = 16;
    static final int STARTING_DELIMITED = 19;
    static final int ENDING_DELIMITED = 20;
    static final int IN = 21;
    static final int OVERLAPS = 24;
    static final int OVERLAPS_START = 25;
    static final int OVERLAPS_END = 26;
    static final int STARTING = 49;
    static final int ENDING = 50;
    static final int ANYWHERE_BEFORE = 51;
    static final int ANYWHERE_AFTER = 52;
    static final int DESCENDANT = 72;
    static final int ANCESTOR = 73;  

    /* other */
    static final int PREFIX = 27;
    static final int IS = 28;
    static final int EITHER = 29;
    static final int OR = 30;
    static final int THEN = 31;
    static final int FLATTEN = 32;
    static final int MELT = 33;
    static final int SEPARATED_BY = 34;
    static final int BALANCES = 35;
    static final int WITH = 36;
    static final int IGNORE = 37;
    static final int TRIM = 38;
    static final int NOT = 39;
    static final int CASE_SENSITIVE = 41;
    static final int NOT_CASE_SENSITIVE = 42;
    static final int NTH = 43;
    static final int AS_TEXT = 47;
    static final int AS_HTML = 48;
    
    static final int AND = 55;
    static final int INCLUDE = 57;
    static final int FROM = 59;
    static final int TO = 60;
    static final int NONEMPTY = 61; 

    static final int STARTOF = 62; 
    static final int ENDOF = 63;

    static final int LEFTPAREN = 64; 
    static final int RIGHTPAREN = 65; 

    static final int LEFTCURLY = 66; 
    static final int RIGHTCURLY = 67; 

    static final int CLOSED_LEFT = 70; 
    static final int CLOSED_RIGHT = 71;
    static final int UNBIND = 74; // largest symbol number in use
}

