/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.tc;

public class Traversal implements Visitor {
    public Object forAnd (TC.And n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forOr (TC.Or n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forButNot (TC.ButNot n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forOrButNot (TC.OrButNot n){
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        n.getArg3 ().accept (this);
        return null;
    }
    public Object forEquals (TC.Equals n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forBefore (TC.Before n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forAfter (TC.After n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forJustBefore (TC.JustBefore n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forJustAfter (TC.JustAfter n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forBeforeDelimited (TC.BeforeDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forAfterDelimited (TC.AfterDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forJustBeforeDelimited (TC.JustBeforeDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forJustAfterDelimited (TC.JustAfterDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forIn (TC.In n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forContains (TC.Contains n) {
        n.getArg ().accept (this);
        return null;
    }

    public Object forDescendant (TC.Descendant n) {
	n.getArg ().accept (this);
	return null;
    }
    public Object forAncestor (TC.Ancestor n) {
	n.getArg ().accept (this);
	return null;
    }

    public Object forStarting (TC.Starting n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forEnding (TC.Ending n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forStartingDelimited (TC.StartingDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forEndingDelimited (TC.EndingDelimited n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forOverlapsStart (TC.OverlapsStart n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forOverlapsEnd (TC.OverlapsEnd n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forOverlaps (TC.Overlaps n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forSeparatedBy (TC.SeparatedBy n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forStartOf (TC.StartOf n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forEndOf (TC.EndOf n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forBalancedUnary (TC.BalancedUnary n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forBalancedBinary (TC.BalancedBinary n){
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forFromTo (TC.FromTo n){
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forConstant (TC.Constant n) {
        return null;
    }
    public Object forExternalPattern (TC.ExternalPattern n) {
        return null;
    }
    public Object forLiteral (TC.Literal n) {
        return null;
    }
    public Object forRegexp (TC.Regexp n) {
        return null;
    }
    public Object forId (TC.Id n) {
        return null;
    }
    public Object forAny (TC.Any n) {
        return null;
    }
    public Object forNothing (TC.Nothing n) {
        return null;
    }
    public Object forNextTo (TC.NextTo n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forTrim (TC.Trim n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forInclude (TC.Include n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forAssign (TC.Assign n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forSeq (TC.Seq n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forIgnoreBinary (TC.IgnoreBinary n) {
        n.getArg1 ().accept (this);
        n.getArg2 ().accept (this);
        return null;
    }
    public Object forNth (TC.Nth n){
        n.getCounter ().accept (this);
        n.getContext ().accept (this);
        return null;
    }
    public Object forFlatten (TC.Flatten n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forUnbind (TC.Unbind n) {
	n.getArg().accept(this);
	return null;
    }
    public Object forMelt (TC.Melt n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forCrispen (TC.Crispen n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forNonempty (TC.Nonempty n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forPrefix (TC.Prefix n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forCaseSensitivity (TC.CaseSensitivity n) {
        n.getArg ().accept (this);
        return null;
    }
    public Object forView (TC.View n) {
        n.getArg ().accept (this);
        return null;
    }
}
