/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.tc;

public interface Visitor {
    public Object forConstant (TC.Constant n);
    public Object forExternalPattern (TC.ExternalPattern n);
    public Object forLiteral (TC.Literal n);
    public Object forRegexp (TC.Regexp n);
    public Object forId (TC.Id n);
    public Object forAny (TC.Any n);
    public Object forNothing (TC.Nothing n);
    public Object forEquals (TC.Equals n);
    public Object forBefore (TC.Before n);
    public Object forAfter (TC.After n);
    public Object forJustBefore (TC.JustBefore n);
    public Object forJustAfter (TC.JustAfter n);
    public Object forBeforeDelimited (TC.BeforeDelimited n);
    public Object forAfterDelimited (TC.AfterDelimited n);
    public Object forJustBeforeDelimited (TC.JustBeforeDelimited n);
    public Object forJustAfterDelimited (TC.JustAfterDelimited n);
    public Object forIn (TC.In n);
    public Object forContains (TC.Contains n);

    public Object forDescendant (TC.Descendant n);
    public Object forAncestor (TC.Ancestor n);

    public Object forStarting (TC.Starting n);
    public Object forEnding (TC.Ending n);
    public Object forStartingDelimited (TC.StartingDelimited n);
    public Object forEndingDelimited (TC.EndingDelimited n);
    public Object forOverlapsStart (TC.OverlapsStart n);
    public Object forOverlapsEnd (TC.OverlapsEnd n);
    public Object forOverlaps (TC.Overlaps n);
    public Object forSeparatedBy (TC.SeparatedBy n);
    public Object forStartOf (TC.StartOf n);
    public Object forEndOf (TC.EndOf n);
    public Object forBalancedUnary (TC.BalancedUnary n);
    public Object forFlatten (TC.Flatten n);
    public Object forUnbind (TC.Unbind n);
    public Object forMelt (TC.Melt n);
    public Object forCrispen (TC.Crispen n);
    public Object forNonempty (TC.Nonempty n);
    public Object forAnd (TC.And n);
    public Object forOr (TC.Or n);
    public Object forButNot (TC.ButNot n);
    public Object forNextTo (TC.NextTo n);
    public Object forTrim (TC.Trim n);
    public Object forInclude (TC.Include n);
    public Object forSeq (TC.Seq n);
    public Object forBalancedBinary (TC.BalancedBinary n);
    public Object forFromTo (TC.FromTo n);
    public Object forIgnoreBinary (TC.IgnoreBinary n);
    public Object forAssign (TC.Assign n);
    public Object forOrButNot (TC.OrButNot n);
    public Object forNth (TC.Nth n);
    public Object forPrefix (TC.Prefix n);
    public Object forCaseSensitivity (TC.CaseSensitivity n);
    public Object forView (TC.View n);

}
