/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.tools;

import lapis.*;
//import java.io.*;
//import java.util.Enumeration;
import lapisx.util.History;

public class Back implements Tool {
    
    public Document invoke (Arguments args) throws Exception {
        int steps = 1;

        args.setUsage (
        "Usage:\n"
        +"   back       backs up to previous document in history\n"
        +"   back <n>   backs up n documents in history\n"
        +"\n"
        +"Options:\n"
        +"    -help                  Display this message\n"
        );
        while (args.hasMoreElements ()) {
            String name = args.nextName ();
            if (name == null)
                steps = args.nextInt (); 
            else
                args.consume (name);
        }

        Interpreter interp = args.getInterpreter ();
        History history = (History) interp.getVar (Interpreter.HISTORY_VAR);
        Document doc = (Document) history.get ();
        for (; steps > 0 && history.canBack (); --steps)
            doc = (Document) history.back ();
        return doc;
    }
}
