/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapis.trees;

import junit.framework.*;
import lapis.*;

/**
 * Tests for bugs in LazyRelop.
 */
public class LazyRelopTest extends TestCase {

    public void testIn () {
        try {
            Document doc = BasicDocument.defaultFactory.make (new java.io.File ("/usr/rcm/lapis/quickstart.html"));
            MutableRegionSet s = new MutableRegionSet ();
                    
            s.insert (0, 10, doc.getVersion ());
            s.insert (20, 30, doc.getVersion ());
            
            RegionSet inS = s.in ();
            
            assertEquals (2,  inS.getSize());
            
            RegionEnumeration re = inS.regions();
            assertEquals (new FuzzyRegion (0, 10, 0, 10, doc), re.first());
            assertEquals (new FuzzyRegion (20, 30, 20, 30, doc), re.next());
            assertNull (re.next ());
        } catch (java.io.IOException e) {
            fail (e.toString ());
        }
    }
}
