/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapisx.enum;
import java.util.Enumeration;
import java.util.NoSuchElementException;

/**
 * Enumeration which always returns no elements.
 */
public class EmptyEnumeration implements Enumeration, RestartableEnumeration {
    public EmptyEnumeration () {
    }

    public boolean hasMoreElements () { 
        return false;
    }

    public Object nextElement () { 
        throw new NoSuchElementException ();
    }

    public void restart () {
    }
}
