/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.io;

import java.io.*;

public abstract class Line {

    public static String readLine (InputStream in, int max) throws IOException {
        StringBuffer buf = new StringBuffer ();
        int i;
        int c = 0;
        for (i = 0; i < max && (c = in.read ()) != -1 && c != '\n'; ++i)
            buf.append ((char) c);

        if (i == 0 && c == -1)
            return null; // EOF

        String line = buf.toString ();
        return line;
    }

    public static void writeLine (OutputStream out, String line) throws IOException {
        for (int i = 0, n = line.length (); i < n; ++i)
            out.write (line.charAt(i));
        out.write ('\n');
    }
}
