/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.progress;

public class ProgressEvent extends java.util.EventObject {
    String label = "";
    int minimum = 0;
    int maximum = 100;
    int value = 0;

    public ProgressEvent (Object source) {
        super (source);
    }

    public String getLabel () {
        return label;
    }
    public void setLabel (String lbl) {
        label = lbl;
    }    

    public int getMinimum () {
        return minimum;
    }
    public void setMinimum (int min) {
        minimum = min;
    }

    public int getMaximum () {
        return maximum;
    }
    public void setMaximum (int max) {
        maximum = max;
    }

    public int getValue () {
        return value;
    }
    public void setValue (int val) {
        value = val;
        if (value < minimum)
            value = minimum;
        if (value > maximum)
            value = maximum;
    }

    public double getPercentComplete () {
        return ((double) (value - minimum)) / (maximum - minimum);
    }

    public void setPercentComplete (double pct) {
        value = (int) (pct * (maximum - minimum) + minimum);
        if (value < minimum)
            value = minimum;
        if (value > maximum)
            value = maximum;
    }
}
