/*
 * LAPIS utility classes
 * Copyright (C) 1998-2002 Carnegie Mellon University. All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Library
 * General Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://www.cs.cmu.edu/~rcm/lapis/
 */
package lapisx.sort;


    public class PointerSort { 
	public static lapisx.util.Debug debug = lapisx.util.Debug.QUIET;
	int[] a;
	int[] b;
	
	public PointerSort (int[] originalArray) {
	    a = originalArray;
	    b = new int[a.length];
	    for (int i = 0; i < b.length; i ++ )
		b[i] = i;
	    debug.println("size: " + b.length);
// 	    for (int i = 0; i < b.length; i ++ )
// 		b[i] = (int) (Math.random() *100);
	}

	private void swap(int i, int j) {
	    int temp = b[i];
	    b[i] = b[j];
	    b[j] = temp;
	    for (int k = 0; k < b.length ; k++ ) {
		debug.print(" " +b[k] );

	    }
	    debug.println("");
	    debug.print("value " );
	    for (int k = 0; k < b.length ; k++ ) {
		debug.print(" " +a[b[k]] );

	    }
	    debug.println("");

	}
	public int[] pointerArray() {
	    return b;
	}
	public void sort() {
	    sort (0,b.length-1);
	} 
	public int get(int i) { 
	    return b[i];
	}
	public void sort(int low, int high){

	    // Initialize pointers
	    int top = low,
		bottom = high - 1,
		part_index,
		part_value;
	    debug.println("low: " + low + " high "   + high);
	    // Do nothing if low >= high
	    if (low < high)
		{
		    // Check if elements are sequential
		    if (high == (low + 1))
			{
			    if (a[b[low]]> a[b[high]])
				swap(high, low);
			}
		    else
			{
			    // Choose a partition element and swap it with the last value in
			    // the array
			    part_index = (int)((low + high) / 2);
			    part_value = a[b[part_index]];
			    swap(high, part_index);
			    debug.println("part index: " + part_index + " part value "   + part_value);
			    do
				{
				    // Inrement the top pointer
				    while ((a[b[top]] <= part_value) && (top <= bottom))
					top++;
				    debug.println("top: " + top + " bottom: " + bottom);
				    // Decrement the bottom pointer
				    while ((top <= bottom) && (a[b[bottom]] > part_value)){
					debug.println("top2: " + top + " bottom2: " + bottom);
					bottom--;
					debug.println("top3: " + top + " bottom3: " + bottom);
				    }
				    debug.println("bottom: " + bottom);
				    // Swap elements if pointers have not met
				    if (top < bottom)
					swap(top, bottom);
				} while (top < bottom);
			    
			    // Put the partition element back where it belongs
			    swap(top, high);
			    
			    // Recursive calls
			    sort(low, top - 1);
			    sort(top + 1, high);
			}
		}
	}
	
	
	
	
    } 
