/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.sort;

public class SortableArray implements Sortable {
    protected Object[] array;
    protected int n;

    public SortableArray (Object[] array) {
        this.array = array;
        this.n = array.length;
    }

    public SortableArray (Object[] array, int n) {
        this.array = array;
        this.n = n;
    }

    public Object get (int i) {
        return array[i];
    }

    public void set (int i, Object o) {
        array[i] = o;
    }

    public int size () {
        return n;
    }

    public void swap (int i, int j) {
        Object tmp = array[i];
        array[i] = array[j];
        array[j] = tmp;
    }

    public int compare (Object o1, Object o2) {
        return o1.toString().compareTo (o2.toString ());
    }
}
