/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.sort;

import java.util.Vector;

public class SortableVector implements Sortable {
    protected Vector v;

    public SortableVector (Vector v) {
        this.v = v;
    }

    public Object get (int i) {
        return v.elementAt (i);
    }

    public void set (int i, Object o) {
        v.setElementAt (o, i);
    }

    public int size () {
        return v.size ();
    }

    public void swap (int i, int j) {
        Object tmp = v.elementAt (i);
        v.setElementAt (v.elementAt (j), i);
        v.setElementAt (tmp, j);
    }

    public int compare (Object o1, Object o2) {
        return o1.toString().compareTo (o2.toString ());
    }
}
