/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.sort;

public class StringSortableList implements SortableList {
    String value;
    SortableList nextPtr;

    public StringSortableList (String value, SortableList nextPtr) { 
        this.value = value; 
        this.nextPtr = nextPtr;
    }

    public Object get () { return value; }

    public SortableList next () { return nextPtr; }

    public void setNext (SortableList l) { nextPtr = l; }

    public int compareTo (SortableList l) { 
        return value.compareTo ((String)l.get ());
    }

    public void dump () {
        System.out.print (value + " ");
        if (nextPtr != null)
            ((StringSortableList)nextPtr).dump ();
    }

    public static StringSortableList make (String[] words) {
        return make (words, 0);
    }

    private static StringSortableList make (String[] words, int i) {
        if (i >= words.length)
            return null;
        return new StringSortableList (words[i], make (words, i+1));
    }                

}
