/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.swing;

import javax.swing.*;

public class AcceleratedMenu extends JMenu {
    public AcceleratedMenu (String name) {
        int ampersand = name.indexOf ('&');
        if (ampersand > -1 && ampersand < name.length()) {
            char mnemonic = Character.toUpperCase (name.charAt (ampersand+1));
            setMnemonic (mnemonic);
            name = name.substring (0, ampersand) + name.substring (ampersand + 1);
        }
        setText (name);
    }

    public JMenuItem add (Action action) {
        JMenuItem item = super.add (action);

        Object mn = action.getValue (AcceleratedAction.MNEMONIC);
        if (mn != null)
            item.setMnemonic (((Character)mn).charValue ());

        Object acc = action.getValue (AcceleratedAction.ACCELERATOR);
        if (acc != null)
            item.setAccelerator ((KeyStroke) acc);

        return item;
    }
}

