/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.swing;

import java.awt.event.*;
import java.beans.*;
import javax.swing.*;

public class ExtendedAction implements Action {
    Action delegate;

    public ExtendedAction (Action delegate) {
        this.delegate = delegate;
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        delegate.addPropertyChangeListener (listener);
    }

    public Object getValue (String name) {
        return delegate.getValue (name);
    }

    public boolean isEnabled() {
        return delegate.isEnabled ();
    }

    public void putValue(String name, Object value) {
        delegate.putValue (name, value);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        delegate.removePropertyChangeListener (listener);
    }

    public void setEnabled(boolean f) {
        delegate.setEnabled (f);
    }

    public void actionPerformed (ActionEvent e) {
        delegate.actionPerformed (e);
    }
}

