/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.swing;

import javax.swing.*;

public class HighlightingScrollBar extends JScrollBar {
    ScrollBarHighlighter highlighter;

    static {
        UIManager.put ("HighlightingScrollBarUI", "lapisx.swing.HighlightingScrollBarUI");
    }


    public HighlightingScrollBar () {
        super ();
    }
    
    public HighlightingScrollBar (int orientation) {
        super (orientation);
    }
    
    public String getUIClassID () {
        return "HighlightingScrollBarUI";
    }
    
    public void setHighlighter (ScrollBarHighlighter h) {
        this.highlighter = h;
    }
        
    public ScrollBarHighlighter getHighlighter () {
        return highlighter;
    }
}
