/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */

package lapisx.swing;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;

public class HighlightingScrollBarUI extends MetalScrollBarUI {
    public void paint (Graphics g, JComponent c) {
        super.paint (g, c);
        ScrollBarHighlighter h = ((HighlightingScrollPane.HighlightingScrollBar) c).getHighlighter ();
        if (h != null)
            h.paintScrollBarHighlights (g, (JScrollBar) c, 
                                        getTrackBounds (),
                                        incrButton.getBounds (),
                                        decrButton.getBounds ());
    }

    public static ComponentUI createUI (JComponent c) {
        return new HighlightingScrollBarUI ();
    }
}

