/*
 * LAPIS lightweight structured text processing system
 *
 * Copyright (C) 1998-2002 Carnegie Mellon University,
 * Copyright (C) 2003 Massachusetts Institute of Technology.
 * All rights reserved.
 *
 * This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation, version 2.
 *
 * LAPIS homepage: http://graphics.lcs.mit.edu/lapis/
 */


package lapisx.util;

import java.util.Hashtable;

/**
 * Subclass of Hashtable that supports merging the existing object
 * stored in the hashtable with a new object.
 */
public abstract class MergingHashtable extends Hashtable {

    public Object add (Object key, Object value) {
        Object curr = get (key);
        if (curr != null)
            value = merge (curr, value);
        return put (key, value);
    }

    protected abstract Object merge (Object current, Object addition);

}
