#include <win32exec.h>

/*
 * Class:     lapisx_util_Exec
 * Method:    putenv
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT jboolean JNICALL Java_lapisx_util_Exec_putenv
    (JNIEnv * env, jclass cls, jstring str) {
    int result;
    const char *s;

    // convert the jstring to a C string
    s = (*env)->GetStringUTFChars (env, str, 0);

    // make call
#ifdef DEBUG
    fprintf (stderr, "putenv(%s)", s);
#endif
    result = putenv (s);
#ifdef DEBUG
    fprintf (stderr, " returned (%d)\n", result);
#endif
    // Release the jstring
    (*env)->ReleaseStringUTFChars (env, str, s);

    return (result == 0) ? JNI_TRUE : JNI_FALSE;
}

/*
 * Class:     lapisx_util_Exec
 * Method:    chdir
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT jboolean JNICALL Java_lapisx_util_Exec_chdir
    (JNIEnv *env, jclass clas, jstring str) {
    int result;
    const char *s;

    // convert the jstring to a C string
    s = (*env)->GetStringUTFChars (env, str, 0);

    // make call
#ifdef DEBUG
    fprintf (stderr, "chdir(%s)", s);
#endif
    result = _chdir (s);
#ifdef DEBUG
    fprintf (stderr, " returned (%d)\n", result);
#endif

    // Release the jstring
    (*env)->ReleaseStringUTFChars (env, str, s);

    return (result == 0) ? JNI_TRUE : JNI_FALSE;
}
